//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#pragma once
#include "ResizableLib\ResizableDialog.h"
#include "SplitterControl.h"
#include "BtnST.h"
#include "TabCtrl.hpp"
#include "UploadListCtrl.h"
#include "DownloadListCtrl.h"
#include "QueueListCtrl.h"
#include "ClientListCtrl.h"
#include "downloadclientsctrl.h" // Stormit: DTW
#include "progressctrlX.h" // WiZaRd ProgressBar

class CUploadListCtrl;
class CDownloadListCtrl;
class CQueueListCtrl;
class CClientListCtrl;

class CTransferWnd : public CResizableDialog
{
	DECLARE_DYNAMIC(CTransferWnd)

public:
	CTransferWnd(CWnd* pParent = NULL);   // standard constructor
	virtual ~CTransferWnd();

	enum EWnd1Icon {
		w1iSplitWindow = 0,
		w1iDownloadFiles,
		w1iUploading,
		w1iDownloading,
		w1iOnQueue,
		w1iClientsKnown,
		wliOnReserve
	};

	enum EWnd2 {
		wnd2Downloading = 0,
		wnd2Uploading = 1,
		wnd2OnQueue = 2,
		wnd2Clients = 3,
		wnd2OnReserve = 4
	};
	void ShowQueueCount(uint32 number);
	void UpdateListCount(EWnd2 listindex, int iCount = -1);
	void	DropAllFullQ();//[ionix] Drop Menue Buttons
	void	DropAllNNS();//[ionix] Drop Menue Buttons
	void	DropAllTooMany();//[ionix] Drop Menue Buttons
	void	DropAllHighQueueSources();//[ionix] Drop Menue Buttons

	void Localize();
	void UpdateCatTabTitles(bool force=true);
	void VerifyCatTabSize();
	void SwitchUploadList();
	int	Mod_Version_Sort_by_String  (const CUpDownClient *client1, const CUpDownClient *client2); // Pawcio: Mod Version
	void ResetTransToolbar(bool bShowToolbar, bool bResetLists = true);

	// Dialog Data
	enum { IDD = IDD_TRANSFER };
	CUploadListCtrl		uploadlistctrl;
	CUploadListCtrl			reservedlistctrl; //Pawcio: BC
	CDownloadListCtrl	downloadlistctrl;
	CQueueListCtrl		queuelistctrl;
	CClientListCtrl		clientlistctrl;
	CToolTipCtrl		m_tooltipCats;
	CDownloadClientsCtrl	downloadclientsctrl; // Stormit: DTW

protected:
	CSplitterControl m_wndSplitter;
	EWnd2		m_uWnd2;
	bool downloadlistactive;
	CButtonST m_uplBtn;
	// Pawcio: CQV
	CButtonST m_up_q;
	CButtonST m_down_q;
	CButtonST m_wait_q;
	CButtonST m_client_q;
	// <--- Pawcio: CQV
	
	TabControl m_dlTab;
	int	rightclickindex;
	int m_nDragIndex;
	int m_nDropIndex;
	int m_nLastCatTT;
	int	m_isetcatmenu;
	bool m_bIsDragging;
	CImageList* m_pDragImage;
	HICON icon_download;
	POINT m_pLastMousePoint;	


	void ShowWnd2(EWnd2 uWnd2);
	void	SetWnd2(EWnd2 uWnd2);
	void DoResize(int delta);
	void UpdateSplitterRange();
	void SetInitLayout();
	void DoSplitResize(int delta);
	void SetAllIcons();
	void SetWnd2Icon();
	void UpdateTabToolTips() {UpdateTabToolTips(-1);}
	void UpdateTabToolTips(int tab);
	CString GetTabStatistic(uint8 tab);
	int GetTabUnderMouse(CPoint* point);
	int GetItemUnderMouse(CListCtrl* ctrl);
	CString GetCatTitle(int catid);
	int AddCategory(CString newtitle,CString newincoming,CString newcomment,CString newautocat,bool addTab=true);
	void EditCatTabLabel(int index,CString newlabel);
	//void EditCatTabLabel(int index); // [ionix] - Modified Categories
	void	ShowList(uint32 dwListIDC);
	void	ChangeDlIcon(EWnd1Icon iIcon);
	void	OnBnClickedDownUploads(bool bReDraw = false);

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual LRESULT DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	
	DECLARE_MESSAGE_MAP()
	afx_msg void OnHoverUploadList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnHoverDownloadList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTcnSelchangeDltab(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRclickDltab(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnBegindrag(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTabMovement(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLvnKeydownDownloadlist(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnSysColorChange();
	afx_msg void OnDblclickDltab();
	afx_msg void OnBnClickedQueueRefreshButton();

	//[ionix] Drop Menue Buttons start
private:
	CButtonST	m_DropAllFullQBtn;//[ionix] Drop Menue Buttons
	CButtonST	m_DropAllNNSBtn;//[ionix] Drop Menue Buttons
	CButtonST	m_DropTooManyBtn;//[ionix] Drop Menue Buttons
	CButtonST	m_DropAllHighQueueSourcesQBtn;//[ionix] Drop Menue Buttons
	//[ionix] Drop Menue Buttons End
 //>>> ProgressBars  
protected:  
    UINT_PTR m_hTimer;  
    void static CALLBACK ProgessBarTimer(HWND hwnd, UINT uiMsg, UINT idEvent, DWORD dwTime);  
public:  
    CProgressCtrlX m_pRAMBar;  
    CProgressCtrlX m_pCPUBar;  
	void	HideProgressBars();
	void	ShowProgressBars();
//<<< ProgressBars
};
